/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: VERIFICA_COTACAO_SOLICIMP                                         */
/* Tabela : ITEMSOLI                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 16/10/2006 - Raquel Cunha                                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER VERIFICA_COTACAO_SOLICIMP
BEFORE INSERT OR UPDATE OR DELETE ON ITEMSOLI FOR EACH ROW
DECLARE
  V_COUNTITEM VARCHAR2(50);
  V_CDFILCENTCMP VARCHAR2(4);
BEGIN
   V_COUNTITEM := 0;
   IF INSERTING THEN
      IF (NVL(:NEW.IDSOLIIMP, 'N') = 'S') THEN
         SELECT
            NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) AS CDFILCENTCMP
         INTO
            V_CDFILCENTCMP
         FROM
            FILIAL FIL,
            FILIAL
         WHERE
            FILIAL.CDFILIAL = :NEW.CDFILSOLI  AND
            NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = FIL.CDFILIAL;

         SELECT
            COUNT (ITEMCOLE.CDPRODUTO)
         INTO
            V_COUNTITEM
         FROM
            ITEMCOLE, FILIAL
         WHERE
             ITEMCOLE.CDPRODUTO = :NEW.CDPRODUTO  AND
             ITEMCOLE.CDFILIAL  = V_CDFILCENTCMP  AND
             :NEW.DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM AND
             ITEMCOLE.CDFILIAL  = FILIAL.CDFILIAL AND
             ITEMCOLE.CDREGIAO  = FILIAL.CDREGIAO;

         IF V_COUNTITEM > 0 THEN
            raise_application_error(-20501, 'Operao bloqueada! Existe(m) cotao(es) para a(s) solicitao(es) importada(s).', True);
         END IF;
      END IF;
   END IF;
   V_COUNTITEM := 0;
   IF UPDATING THEN
      IF (NVL(:OLD.IDSOLIIMP, 'N') = 'S') THEN
         SELECT
            NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) AS CDFILCENTCMP
         INTO
            V_CDFILCENTCMP
         FROM
            FILIAL FIL,
            FILIAL
         WHERE
            FILIAL.CDFILIAL = :OLD.CDFILSOLI  AND
            NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = FIL.CDFILIAL;

         SELECT COUNT (ITEMCOLE.CDPRODUTO)
         INTO
            V_COUNTITEM
         FROM
            ITEMCOLE, FILIAL
         WHERE
             ITEMCOLE.CDPRODUTO = :OLD.CDPRODUTO  AND
             ITEMCOLE.CDFILIAL  = V_CDFILCENTCMP  AND
             :NEW.DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM AND
             ITEMCOLE.CDFILIAL  = FILIAL.CDFILIAL AND
             ITEMCOLE.CDREGIAO  = FILIAL.CDREGIAO;
         IF V_COUNTITEM > 0 THEN
            raise_application_error(-20501, 'Operao bloqueada! Existe(m) cotao(es) para a(s) solicitao(es) importada(s).', True);
         END IF;
      END IF;
   END IF;
   V_COUNTITEM := 0;
   IF DELETING THEN
      IF (NVL(:OLD.IDSOLIIMP, 'N') = 'S') THEN
         SELECT
            NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) AS CDFILCENTCMP
         INTO
            V_CDFILCENTCMP
         FROM
            FILIAL FIL,
            FILIAL
         WHERE
            FILIAL.CDFILIAL = :OLD.CDFILSOLI  AND
            NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = FIL.CDFILIAL;

         SELECT COUNT (ITEMCOLE.CDPRODUTO)
         INTO
            V_COUNTITEM
         FROM
            ITEMCOLE, FILIAL
         WHERE
             ITEMCOLE.CDPRODUTO = :OLD.CDPRODUTO  AND
             ITEMCOLE.CDFILIAL  = V_CDFILCENTCMP  AND
             :NEW.DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM AND
             ITEMCOLE.CDFILIAL  = FILIAL.CDFILIAL AND
             ITEMCOLE.CDREGIAO  = FILIAL.CDREGIAO;


         IF V_COUNTITEM > 0 THEN
            raise_application_error(-20501, 'Operao bloqueada! Existe(m) cotao(es) para a(s) solicitao(es) importada(s).', True);
         END IF;
      END IF;
   END IF;
END;
/
